;ͻ
; Programm  Lauflich.asm                                                  
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.05.98                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor     Inga Anita Fischer und Thomas Gnielka                         
;Ķ
; Inhalt    Lauflicht, Ein/Ausgabe mit 8255                               
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486			;Prozessortyp angeben, 486 Code zulassen
	DOSSEG			;Segmente DOS-konform anordnen
	.MODEL USE16 SMALL	;Speichermodell auswaehlen
	STACK   100h		;Stackgroee definieren

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS		equ 21h	;MS-DOS Interruptnummer
	EXIT   	 	equ 4Ch	;Programmende

;Ŀ
;  Konstanten fuer den I/O-Baustein 8255                                  
;
	PortA		equ 300h;Adresse Port A
	PortB		equ 301h;Adresse Port B
	CntlReg		equ 303h;Adresse Kontrollregister
	LslReset	equ 9Bh

;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG
	Eingabe		db 0
	Ausgabe		db 0

;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

;͸
; Unterprogramme                                                           
;;
;Ŀ
; I/O-Baustein 8255 initialisieren                                         
;
InitPorts proc           ;8255-Baustein initialisieren
	push	ax	;alle im Unterprogramm benutzte Register sichern
	push	dx
	mov 	al, 8Bh
	mov	dx, CntlReg	
	out 	dx, al 
	pop	dx	;Register restaurieren
	pop	ax
	ret		;Ruecksprung
InitPorts endp		;Unterprogramm Ende


;Ŀ
; Port A,B und C zuruecksetzen (alle auf Eingang)                          
;
ResetPorts proc         ;8255-Baustein zuruecksetzen
	push	ax	;alle im Unterprogramm benutzte Register sichern
	push	dx
	mov 	al, LslReset
	mov	dx, CntlReg
	out	dx, al
	pop	dx	;Register restaurieren
	pop	ax
	ret		;Ruecksprung
ResetPorts endp		;Unterprogramm Ende


;Ŀ
; Port B einlesen                                                          
;
ReadPortB proc          ;Liest Port B und uebergibt ihn ueber Stack an main
	push	bp
	mov	bp, sp
	push	ax	;alle im Unterprogramm benutzte Register sichern
	push	dx
	mov	dx, PortB
	in	al, dx
	mov	[bp + 4], al
        pop	dx	;Register restaurieren
	pop	ax
	pop	bp
	ret		;Ruecksprung
ReadPortB endp		;Unterprogramm Ende	


;Ŀ
; Port A ausgeben                                                          
;
WritePortA proc         ;Uebergebene Parameter auf Port A ausgeben
	push 	bp
	mov	bp, sp
	push 	ax
	push	dx
	mov	dx, PortA
	mov	al, [bp + 4]
	out	dx, al	
	pop 	dx
	pop	ax
	pop	bp
	ret	2	;Ruecksprung
WritePortA endp		;Unterprogramm Ende


;͸
; Hauptprogramm                                                            
;;
Main:	mov     ax,@DATA	;Datensegment laden
	mov     ds,ax
	call	InitPorts
	mov	bx, 0000h
	mov	dx, 0000h
	mov	di, 0000h
Loop1:	
	push 	bx	
	call	ReadPortB
	pop	bx
	cmp	bx, di
	jz	Weiter1
        mov	dx, bx
	mov	di, dx
        call 	Weiter2

Weiter1:
	ror	dl, 1 

Weiter2:
	push	dx
	call 	WritePortA	
	mov	ecx, 9FFFFh
Loop2:	
	loopd 	Loop2

	cmp	dl, 0FFh	
	jnz	Loop1	

	call 	ResetPorts	;Zuruecksetzen des 8255
	xor	ax,ax		;Programm beenden
	mov     ah,Exit
	int     msdos
end	Main

