;ͻ
; Programm  Drucker.asm                                                   
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.07.94                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor     Thomas Gnielka und Inga Anita Fischer                         
;Ķ
; Inhalt    Serielle Datenuebertragung mit dem 8250A                      
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486                    ;Prozessortyp angeben, 486 Code zulassen
	DOSSEG                  ;Segmente DOS-konform anordnen
	.MODEL USE16 SMALL      ;Speichermodell auswaehlen
	STACK   100h            ;Stackgroee definieren

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS           equ 21h ;MS-DOS Interruptnummer
	EXIT            equ 4Ch ;Programmende

;Ŀ
; Register (Umbennenung erlaubt und erwuenscht!!!)                        
;
	SHReg           equ 03E8h       ;Sendehalteregister
	LStatReg        equ 03EDh       ;Leitungsstatusregister
	LSteuReg        equ 03EBh       ;Leitungssteuerregister
	IFReg           equ 03E9h       ;Interruptfreigaberegister

;Ŀ
; Druckersteuerzeichen (Beispiele => Werte anpassen!!!)                   
;
	PrinterReset    equ 1Bh, 40h    ;ESC @ = Drucker initialisieren
	FettEin         equ 1Bh, 45h    ;ESC E = Fettdruck aktivieren
	FettAus         equ 1Bh, 46h    ;ESC F = Fettdruck deaktivieren


;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG
	Zeile1  db 27, 64, 13, 10
	        db "   +++++++++++   ", 13, 10 
		db "  +++++++++++++  ", 13, 10
		db " +############+# ", 13, 10
		db "++###########++##", 13, 10
		db "++##         ++##", 13, 10
		db "++##         ++##", 13, 10
		db "++##         ++##", 13, 10
		db "++##         ++##", 13, 10
		db "++##+++++++++++##", 13, 10
		db " +#++++++++++++# ", 13, 10
		db "  #############  ", 13, 10
		db "   ###########   ", 13, 10
		db 27, 69
		db "J apporte quelques grammes de finesse dans ce monde de brutes", 13, 10
		db 27, 70, 27, 87, 1
		db "Je suis anti-con", 13, 10
		db 27, 87, 0, 27, 45, 1
		db "I can resist everything except temptation", 13, 10, 0FFh

;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

;͸
; Unterprogramme                                                           
;;
;Ŀ
; Baustein 8250A initialisieren                                            
;
InitCom proc            ;8250A-Baustein initialisieren
	push    ax
	push    dx
	mov     ax, 0
	mov     al, 10000011b
	mov     dx, LSteuReg
	out     dx, al
	mov     ax, 0ch
	mov     dx, SHReg
	out     dx, ax
	mov     al, 00000011b
	mov     dx, LSteuReg
	out     dx, al
	mov 	dx, SHReg
	in	al, dx
	mov	dx, LStatReg
	in	al, dx
	pop     dx
	pop     ax
	ret             ;Ruecksprung
InitCom endp            ;Unterprogramm Ende


;Ŀ
; Zeichen senden                                                           
;
SendChar proc           ;ein Zeichen senden
	 push   bp
	 mov    bp, sp
	 push   ax
	 push   dx
	 mov    ax, 0
     
Warten:  in     al, 60h
	 cmp    al,1
	 jnz    weitermachen
	 mov    ah,4ch
	 int    21h
weitermachen:
	 mov    dx, LStatReg
	 in     al, dx
	 test   al, 01000000b
	 jz     Warten
	 
	 mov    al, [bp + 4]
	 mov    dx, SHReg
	 out    dx, al
	 pop    dx
	 pop    ax
	 pop    bp
	 ret    2       ;Ruecksprung
SendChar endp           ;Unterprogramm Ende


;͸
; Hauptprogramm                                                            
;;
Main:   mov     ax,@DATA        ;Datensegment laden
	mov     ds,ax
	call    InitCom         ;Zuruecksetzen des 8250A
	mov     di, offset Zeile1
	mov     dx, 0

Schleife:
	mov     dl, [di]
	cmp     dl, 0FFh
	jz      Weiter
	
	push    dx
	call    SendChar
	inc     di
	jmp     Schleife

Weiter:
	
	xor     ax,ax           ;Programm beenden
	mov     ah,Exit
	int     msdos
end     Main

