;ͻ
; Programm  Ton.asm                                                       
;                                                                         
; Compiler  Turbo Assembler 3.0, TASMX-Oberflaeche 1.54                   
;                                                                         
; Datum     Karlsruhe, den 04.07.94                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor     Inga Anita Fischer und Thomas Gnielka                         
;Ķ
; Inhalt    Musikversuch                                                  
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	TITLE 'Mikrorechnerpraktikum 1'
	P486                    ;Prozessortyp angeben, 486 Code zulassen
	DOSSEG                  ;Segmente DOS-konform anordnen
	.MODEL USE16 SMALL      ;Speichermodell auswaehlen
	STACK   100h            ;Stackgroee definieren

;ͻ
; Konstanendeklaration                                                     
;ͼ
	MSDOS           equ 21h ;MS-DOS Interruptnummer
	EXIT            equ 4Ch ;Programmende

;Ŀ
;  Konstanten fuer Lichtsignale                                           
;


;Ŀ
;  Konstanten fuer den Interruptcontroller 8259A                          
;
	Master  equ 20h         ;Adresse des Kontrollregisters des 1. Inter-
				;ruptcontrollers
	Slave   equ 0A0h        ;Adresse des Kontrollregisters des 2. Inter-
				;ruptcontrollers
	IRQMask_1  equ  21h     ;Adresse der Maske des 1. IR-Controllers
	IRQMask_2  equ 0A1h     ;Adresse der Maske des 2. IR-Controllers
	GetIntVec  equ 35h      ;Funktionscode Get Interrupt Vector
	SetIntVec  equ 25h      ;Funktionscode Set Interrupt Vector
	IRQ10   equ 72h         ;Vektor 72h fuer IRQ10
	EOI     equ 20h         ;End of Interrupt (=20h)

;Ŀ
;  Konstanten fuer den Timerbaustein 8253                                 
;
	Timer0  equ 0304h       ;Adresse Datenregister Zaehler 0
	Timer1  equ 0305h       ;Adresse Datenregister Zaehler 1
	Timer2  equ 0306h       ;Adresse Datenregister Zaehler 2
	TimerContr equ 0307h    ;Adresse Controlregister

;ͻ
; Variablendeklaration mit Anfangswert                                     
;ͼ
		DATASEG

	Zaehler dw 5000 
	Position db 0
	Eingabe	db 1, 2, 32, 4, 0, 16, 0, 8
	Laenge	dw 400
	        dw 200
		dw 100
		dw 50
		dw 25
		dw 13
	Tontabelle dw 18182
	           dw 17161
	           dw 16198
	           dw 15289
	           dw 14431
	           dw 13621
	           dw 12857
	           dw 12135
	           dw 11454
	           dw 10811
	           dw 10205
	           dw 9632
	           dw 9091
	           dw 8581
	           dw 8099
	           dw 7645
	           dw 7216
	           dw 6811
	           dw 6428
	           dw 6068
	           dw 5727
	           dw 5406
	           dw 5102
	           dw 4816
	           dw 4545
	           dw 4290
	           dw 4050
	           dw 3822
	           dw 3608
	           dw 3405
	           dw 3214
	           dw 3034
	           dw 2864
	           dw 2703
	           dw 2551
	           dw 2408
		   
		   
;ͻ
; Variablendeklaration ohne Anfangswert                                    
;ͼ
		UDATASEG
	Vec_Seg         dw ?    ;zur Sicherung von Routine-Segment bei IRQ
	Vec_Ofs         dw ?    ;zur Sicherung von Routine-Offset bei IRQ
	IRQStatus       db ?    ;Status der Interruptroutine (0= aus, 1= ein)
	Toene		db 100 dup (?)    ;Toene von der Tastatur
	Tonlaenge	db 100 dup (?)

;ͻ
; Programmdeklaration                                                      
;ͼ
		CODESEG

;͸
; Unterprogramme                                                           
;;

;Ŀ
;  Einfuegen der Interruptroutine in die Vektortabelle                    
;
InitInter proc  
	push    ax              ;Register sichern
	push    dx

	mov     ah,GetIntVec    ;Funktionscode Get Interrupt Vector
	mov     al,IRQ10        ;IRQ10 wird verwendet, d.h. Vektor 72h
	int     MSDOS           ;int 21h
	mov     [Vec_Seg],es    ;Segment der Routine abspeichern
	mov     [Vec_Ofs],bx    ;Offset der Routine abspeichern

	mov     ah,SetIntVec    ;Funktionscode Set Interrupt Vector
	mov     al,IRQ10        ;Vektornummer laden
	push    ds              ;ds wird noch gebraucht => Register sichern     
	push    cs              ;die neue Interruptroutine steht im gleichen Segment
	pop     ds              ;daher wird der Inhalt von CS nach DS uebertragen
	mov     dx,offset Inter1;Offset der Routine nach DX
	int     MSDOS           ;int 21h

	pop     ds              ;Register restaurieren
	pop     dx
	pop     ax
	ret
InitInter endp

;Ŀ
;  Interrupts auf IRQ10 freigeben                                         
;
IRQ_On proc     
	push    ax              ;Register sichern
	in      al,IRQMask_2    ;Mask-Register des 2. Controllers
	and     al,0FBh         ;Bit 2 loeschen, gibt IRQ 10 frei
	out     IRQMask_2,al    ;Byte zurueckschreiben
	STI                     ;maskierbare Interrupts freigeben
	pop     ax              ;Register restaurieren
	ret
IRQ_On endp     

;Ŀ
;  IRQ10 ausschalten                                                      
;
IRQ_Off proc
	push    ax              ;Register sichern
	in      al,IRQMask_2    ;Mask-Register 2. Controller
	or      al,04h          ;Bit 2 setzen, sperrt Interrupts auf IRQ10
	out     IRQMask_2,al    ;Byte zurueckschreiben  
	pop     ax
	ret
IRQ_Off endp

;Ŀ
;  alte Interruptroutine wieder eintragen                                 
;
ResetInter proc
	push    ax              ;Register sichern
	push    dx
	push    ds                      
	mov     ds,[Vec_Seg]    ;Segment der Routine nach DS
	mov     dx,[Vec_Ofs]    ;Offset der Routine nach DX
	mov     ah,SetIntVec    ;Funktion Set Interrupt Vector
	mov     al,IRQ10        ;Vektornummer laden
	int     MSDOS           ;int 21h
	pop     ds              ;Datensegment restaurieren
	pop     dx              ;Register sichern
	pop     ax
	ret
ResetInter endp


;Ŀ
;  Timer 1 und 2 vorbereiten                                              
;
InitTimer proc
	push    ax
	push    dx
	
	mov     dx, TimerContr
	mov     ax, 01110100b
	out     dx, al
	mov     dx, Timer1
	mov     ax, [Zaehler]
	out     dx, al
	mov	al, ah
	out	dx, al 
	
	mov     dx, TimerContr
	mov     ax, 10110000b
	out     dx, al

	mov	dx, TimerContr
	mov	ax, 00110110b
	out	dx, al

	pop     dx
	pop     ax
	ret
InitTimer endp

;Ŀ
;  Interruptroutine (und mehr wird hier nicht gemacht!!!!!!!!!!!!)        
;                   ("IRQStatus" wird im Hauptprogramm abgefragt!)        
;
Inter1  proc                    ;Interruptroutine          
	push    ax              ;Register sichern
	push    ds      
		
	mov     ax,@DATA        ;Datensegment laden
	mov     ds,ax           ;Ab jetzt kann auf Variablen zugegriffen werden
	
	mov     [IRQStatus],1h  ;Interruptroutine aufgerufen

	mov     al,EOI          ;End-Of-Interrupt-Code laden
	out     Master,al       ;Controllregister Controller 1
	out     Slave,al        ;Controllregister Controller 2
	pop     ds              ;Register restaurieren
	pop     ax              ;Register restaurieren
	iret                    ;Ende der Interruptroutine
Inter1  endp


;͸
; Hauptprogramm                                                            
;;
Main:   mov     ax,@DATA        ;Datensegment laden
	mov     ds,ax
	call    InitInter       ;Interruptroutine in Vektortabelle eintragen 
	call    IRQ_On          ;Interrupt einschalten (freigeben)
	call    InitTimer       ;Timer fuer Programmierung vorbereiten
	mov     [IRQStatus],0   ;InterruptStatusflag zuruecksetzen
	mov	ax, 0
	mov	dx, 0
	mov	[position], 0
	mov	di, offset Tontabelle
	mov	si, offset Toene
	mov	bp, offset Tonlaenge
	
Einlesen:
	mov	ah, 08h
	int	21h
	cmp	al, 27
	jz	Weiter
	mov	ah, 0
	mov	bl, 2
	mul	bl
	sub	ax, 130	
	mov	[si], al
	inc 	si
	jmp 	Einlesen	

Weiter:
	mov 	byte ptr [si], 27
	mov	ax, 0
	mov	ax, si
	sub	ax, offset Toene
	mov	cx, ax
	mov	si, offset Toene

Ausgabe:
;	mov	di, offset Tontabelle
;	in	al, 60h
;	cmp	al, 1
;	jz	Weiter3

;	Timer0 initialisieren!
	mov	dx, Timer0
	mov	al, [si]
	mov	ah, 0	

	add	di, ax
	mov	ax, [di]

;	cmp	al, 27
;	jz	Weiter3	
	out	dx, al		
	mov	al, ah
	out	dx, al
        inc	si

;	Timer2 initialisieren!
	mov	dx, Timer2
	mov	ax, 0
	mov	ax, 400
	out	dx, al
	mov	al, ah
	out	dx, al

Schleife:
	cmp 	[IRQStatus], 1
	jnz	Schleife
	
	mov	[IRQStatus], 0

	loop	Ausgabe

Weiter3:
	mov	ax, 0000h
	mov	dx, Timer2
	out	dx, al
	mov	al, ah
	out	dx, al	
	call    IRQ_Off         ;Interrupt ausschalten 
	call	ResetInter	;alte Interruptroutine wieder eintragen
	xor     ax,ax           ;Programm beenden
	mov     ah,Exit
	int     msdos
end     Main

