;ͻ
; Modul     adda8.asm                                                     
;                                                                         
; Compiler  Turbo Assembler 3.0 / Borland C++ 3.1                         
;                                                                         
; Datum     Karlsruhe, den 01.01.94                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor     Hartung Wilstermann & Claus Albrecht                          
;Ķ
; Inhalt    A/D-Wandler AD 574, D/A Wandler AD 667                        
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	.MODEL SMALL	;Speichermodell auswaehlen

;ͻ
;  Konstantenvereinbarungen                                               
;ͼ
	MSDOS		equ 21h	;MS-DOS Interruptnummer


;Ŀ
;  Konstanten fuer den Interruptcontroller 8259A                          
;
	Master	   equ 20h	;Adresse des Kontrollregisters des 1. Inter-
				;ruptcontrollers
	Slave	   equ 0A0h	;Adresse des Kontrollregisters des 2. Inter-
				;ruptcontrollers
	IRQMask_1  equ  21h	;Adresse der Maske des 1. IR-Controllers
	IRQMask_2  equ 0A1h	;Adresse der Maske des 2. IR-Controllers
	GetIntVec  equ 35h	;Funktionscode Get Interrupt Vector
	SetIntVec  equ 25h	;Funktionscode Set Interrupt Vector
	IRQ10	   equ 72h      ;Vektor 72h fuer IRQ10
	EOI        equ 20h      ;End of Interrupt (=20h)

;Ŀ
;  Konstanten fuer den I/O-Baustein 8255                                  
;
	PortA	equ 300h; Adresse Port A
	PortB	equ 301h; Adresse Port B
	PortC	equ 302h; Adresse Port C
	CntlReg	equ 303h; Adresse Kontrollregister
	LslReset equ 9Bh;


;Ŀ
;  Konstanten fuer den Timerbaustein 8253                                 
;
	Timer0	equ 0304h	;Adresse Datenregister Zaehler 0
	Timer1	equ 0305h	;Adresse Datenregister Zaehler 1
	Timer2	equ 0306h	;Adresse Datenregister Zaehler 2
	TimerContr equ 0307h	;Adresse Controlregister

;Ŀ
;  Konstanten fuer A/D-Wandler AD574                                      
;
	STS	equ 30Ah	;STS-Signal (Bit 7 des EPLD)
	EPLD	equ 308h	;EPLD Ergebnis der A/D-Wandlung

;Ŀ
;  Konstanten fuer D/A-Wandler AD667                                      
;
	EPLDAdressCounter equ 30Ah	;Adresszaehler des EPLD
	EPLDRam	equ 308h	;Ram des EPLD

;ͻ
;  Variablen ohne Anfangswert                                             
;ͼ
	UDATASEG
	Vec_Ofs	dw	?	;zur Sicherung von Routine-Offset bei IRQ
	Vec_seg	dw	?	;zur Sicherung von Routine-Segment bei IRQ
	IRQStatus db    ?	;Status der Interruptroutine (0= aus, 1= ein)

	EXTRN _maxwert:word	;Maximale Anzahl Werte
	EXTRN _werte: word:4096	;Digitaler Wert des A/D-Wandlers

;ͻ
;  Programmdeklaration                                                    
;ͼ
	CODESEG
	PUBLIC _ReadAD
	PUBLIC _WriteAD


;͸
;  Unterprogramme                                                         
;;

;Ŀ
; I/O-Baustein 8255 initialisieren                                         
;
InitPorts proc           ;8255-Baustein initialisieren
	

	ret		;Ruecksprung
InitPorts endp		;Unterprogramm Ende


;Ŀ
; Port A,B und C zuruecksetzen (alle auf Eingang)                          
;
ResetPorts proc         ;8255-Baustein zuruecksetzen


	ret		;Ruecksprung
ResetPorts endp		;Unterprogramm Ende


;Ŀ
;  A/D-Wandler AD574 auf 8 Bit Genauigkeit setzen (ueber Bit 3 des 8255)  
;
InitAD proc


	ret		;Ruecksprung
InitAD endp		;Unterprogramm Ende


;Ŀ
;  Timer initialisieren                                                   
;
InitTimer proc


	ret
InitTimer endp

;͸
;  _ReadAD: Einlesen des A/D-Wandlers (Unterprogramm fuer C-Programm)     
;;
_ReadAD proc	;Lesen des A/D-Wandlers im Polling-Mode
	push ax
	push cx
	push dx
	push bp
	push sp
	push ds
	push ss


	pop ss
	pop ds
	pop sp
	pop bp
	pop dx
	pop cx
	pop ax
	ret
_ReadAD endp

;͸
;  _WriteDA: Ausgabe auf D/A-Wandlers (Unterprogramm fuer C-Programm)     
;;
_WriteDA proc 		;Ausgabe auf D/A-Wandler im Speicher-Modus
	push ax
	push cx
	push dx
	push bp
	push ds

	pop ds
	pop bp
	pop dx
	pop cx
	pop ax
	ret
_WriteDA endp

end


