;ͻ
; Modul     adda8.asm                                                     
;                                                                         
; Compiler  Turbo Assembler 3.0 / Borland C++ 3.1                         
;                                                                         
; Datum     Karlsruhe, den 01.01.94                                       
;                                                                         
; Gruppe                                                                  
;                                                                         
; Autor     Hartung Wilstermann & Claus Albrecht                          
;Ķ
; Inhalt    A/D-Wandler AD 574, D/A Wandler AD 667                        
;ͼ

;ͻ
; Programmkopf                                                             
;ͼ
	.MODEL SMALL	;Speichermodell auswaehlen
	P486

;ͻ
;  Konstantenvereinbarungen                                               
;ͼ
	MSDOS		equ 21h	;MS-DOS Interruptnummer


;Ŀ
;  Konstanten fuer den Interruptcontroller 8259A                          
;
	Master	   equ 20h	;Adresse des Kontrollregisters des 1. Inter-
				;ruptcontrollers
	Slave	   equ 0A0h	;Adresse des Kontrollregisters des 2. Inter-
				;ruptcontrollers
	IRQMask_1  equ  21h	;Adresse der Maske des 1. IR-Controllers
	IRQMask_2  equ 0A1h	;Adresse der Maske des 2. IR-Controllers
	GetIntVec  equ 35h	;Funktionscode Get Interrupt Vector
	SetIntVec  equ 25h	;Funktionscode Set Interrupt Vector
	IRQ10	   equ 72h      ;Vektor 72h fuer IRQ10
	EOI        equ 20h      ;End of Interrupt (=20h)

;Ŀ
;  Konstanten fuer den I/O-Baustein 8255                                  
;
	PortA	equ 300h; Adresse Port A
	PortB	equ 301h; Adresse Port B
	PortC	equ 302h; Adresse Port C
	CntlReg	equ 303h; Adresse Kontrollregister
	LslReset equ 9Bh;


;Ŀ
;  Konstanten fuer den Timerbaustein 8253                                 
;
	Timer0	equ 0304h	;Adresse Datenregister Zaehler 0
	Timer1	equ 0305h	;Adresse Datenregister Zaehler 1
	Timer2	equ 0306h	;Adresse Datenregister Zaehler 2
	TimerContr equ 0307h	;Adresse Controlregister

;Ŀ
;  Konstanten fuer A/D-Wandler AD574                                      
;
	STS	equ 30Ah	;STS-Signal (Bit 7 des EPLD)
	EPLD	equ 308h	;EPLD Ergebnis der A/D-Wandlung

;Ŀ
;  Konstanten fuer D/A-Wandler AD667                                      
;
	EPLDAdressCounter equ 30Ah	;Adresszaehler des EPLD
	EPLDRam	equ 308h	;Ram des EPLD

;ͻ
;  Variablen ohne Anfangswert                                             
;ͼ
	UDATASEG
	Vec_Ofs	dw	?	;zur Sicherung von Routine-Offset bei IRQ
	Vec_seg	dw	?	;zur Sicherung von Routine-Segment bei IRQ
	IRQStatus db    ?	;Status der Interruptroutine (0= aus, 1= ein)

	EXTRN _maxwert:word	;Maximale Anzahl Werte
	EXTRN _werte: word:4096	;Digitaler Wert des A/D-Wandlers

;ͻ
;  Programmdeklaration                                                    
;ͼ
	CODESEG
	PUBLIC _ReadAD
	PUBLIC _WriteDA


;͸
;  Unterprogramme                                                         
;;

;Ŀ
; I/O-Baustein 8255 initialisieren                                         
;
InitPorts proc           ;8255-Baustein initialisieren
	push ax
	push dx
	mov al, 9Ah
	mov dx, CntlReg
	out dx, al
	pop dx
	pop ax
	ret		;Ruecksprung
InitPorts endp		;Unterprogramm Ende


;Ŀ
; Port A,B und C zuruecksetzen (alle auf Eingang)                          
;
ResetPorts proc         ;8255-Baustein zuruecksetzen
	push ax
	push dx
	mov al, LslReset
	mov dx, CntlReg
	out dx, al
	pop dx
	pop ax
	ret		;Ruecksprung
ResetPorts endp		;Unterprogramm Ende


;Ŀ
;  A/D-Wandler AD574 auf 8 Bit Genauigkeit setzen (ueber Bit 3 des 8255)  
;
InitAD proc
	push dx
	push ax
	mov dx, PortC
	in  al, dx
	or  al, 1000b
	out dx, al
	pop ax
	pop dx
	ret		;Ruecksprung
InitAD endp		;Unterprogramm Ende


;Ŀ
;  Timer initialisieren                                                   
;
InitTimer proc
	push dx
	push ax
	mov dx, TimerContr
;	mov al, 10110010b
	mov al, 01110110b
	out dx, al
	mov dx, Timer1
	mov ax, 55                        ; ca. 42 fuer kleine _werte von 55
	out dx, al
	mov al, ah
	out dx, al
	pop ax
	pop dx
	ret
InitTimer endp



;͸
;  _ReadAD: Einlesen des A/D-Wandlers (Unterprogramm fuer C-Programm)     
;;
_ReadAD proc	;Lesen des A/D-Wandlers im Polling-Mode
	push ax
	push cx
	push dx
	push bp
	push ds
	push es
	push ds
	pop  es

	call    InitTimer
;	call    InitPorts
	call    InitAD

	mov 	di, offset _werte
	mov	cx, 4096

	mov     dx, 308h      ; Einmal auslesen (Warum auch immer...)
	in	ax, dx 

Einleseschleife:
	mov	dx, 30Ah

Leseschleife:
	in	al, dx
	test	al, 10000000b
	jz	Leseschleife

	mov	dx, 308h
	insw
	loop 	Einleseschleife

	call    ResetPorts

	pop es
	pop ds
	pop bp
	pop dx
	pop cx
	pop ax
	ret
_ReadAD endp

;͸
;  _WriteDA: Ausgabe auf D/A-Wandlers (Unterprogramm fuer C-Programm)     
;;
_WriteDA proc 		;Ausgabe auf D/A-Wandler im Speicher-Modus
	push ax
	push cx
	push dx
	push bp
	push ds

	call InitPorts
	call InitAD

	mov dx, PortC
	in  al, dx
	and al, 11111000b
	or  al, 00000010b
	out dx, al

	mov dx, 30Ah
	mov ax, 4097
	out dx, ax

	mov cx, 4097
	mov si, offset _werte
	mov dx, 308h

	rep outsw

	mov dx, 30ah
	mov ax, 4095
	out dx, ax

	mov dx, PortC
	in  al, dx
	and al, 11111000b
	out dx, al

	mov dx, TimerContr
;	mov al, 00111100b
	mov al, 00110110b
	out dx, al

	mov dx, Timer0
	mov ax, 100
	out dx, ax

	mov dx, PortC
	in  al, dx
	or  al, 00000100b
	out dx, al

	call    ResetPorts

	pop ds
	pop bp
	pop dx
	pop cx
	pop ax
	ret
_WriteDA endp

end


