/*ͻ
   Programm  Versuch8.c   (anderer Name als asm-Prog. wegen Object-File) 
                                                                         
   Compiler  Turbo Assembler 3.0 / Borland C++ 3.1                       
                                                                         
   Datum     Karlsruhe, den 04.07.94                                     
                                                                         
   Gruppe                                                                
                                                                         
   Autor     Hartung Wilstermann & Ingo Gabriel                          
  Ķ
   Inhalt    Ein- und Aslesen eines AD/DA-Wandlers                       
  ͼ*/

/*ͻ
   Programmkopf                                                           
  ͼ*/
/*Ŀ
   Includedateien einladen                                                
  */
  #include <graphics.h>  	      //Laden verschiedener Bibliotheken
  #include <stdlib.h>           //wie Graphikfunktinen, mathematische
  #include <stdio.h>            //Funktionen, Ein-Ausgabe usw
  #include <conio.h>            //Der DOS-Pfad wird in der
  #include <math.h>             //Entwicklungsumgebung eingestellt


/*Ŀ
   Deklaration fr C-Programm                                             
  */
  const int maxwert = 4096;		  //Anzahl der berechneten Werte (berech.h)
  int werte[4098];              //Ergebnisse der Berechnungen (berech.h)

  #include "berech.h"


/*Ŀ
   Prototypendeklaraton                                                   
  */
	extern void ReadAD(void);     //Einlesen AD-Wandler
	extern void WriteDA(void);    //Ausgabe auf DA-Wandler
  void graphinit(void);
  void sinus(void);             //in <berech.h> definiert
  void rechteck(void);          //in <berech.h> definiert
  void zufall(void);            //in <berech.h> definiert

  #define ANFANGX 40

/*ͻ
   Unterprogramme                                                         
  ͼ*/

/*Ŀ
   Graphiktreiber initialisieren                                          
  */
  void	graphinit(void)
  {
    int gdriver = DETECT, gmode, errorcode;

    initgraph(&gdriver,&gmode,""); 	//Graphiktreiber und-mode ermitteln
    errorcode = graphresult();
    if (errorcode != grOk)
    {
	    cprintf("Graphikfehler: %s\n",grapherrormsg(errorcode));
	    cprintf("Drcken Sie eine Taste um anzuhalten:");
	    getch();
	    exit(1);
    };
    setbkcolor(BLACK);                  //Hintergrundfarbe setzen
  };
/*Ŀ
   Koordinatensystem aufbauen					           
  */
  void koordinaten(void)
  {
		int i,j;
      char buffer[10];

      int SCREENX = getmaxx();
      int SCREENY = getmaxy();

      setcolor(EGA_WHITE);

	// Koordinatenkreuz
		line(0,SCREENY/2,SCREENX,SCREENY/2);
      line(ANFANGX,0,ANFANGX,SCREENY);

      // Y-Beschriftung

      for (i = 0; i <= 5; i++) {
	line(ANFANGX-4,SCREENY/2+SCREENY/11*i,
		  ANFANGX+4,SCREENY/2+SCREENY/11*i);
			sprintf(buffer, "%d", i);
	 outtextxy(0,SCREENY/2+SCREENY/11*i,buffer);
	line(ANFANGX-4,SCREENY/2-SCREENY/11*i,
		  ANFANGX+4,SCREENY/2-SCREENY/11*i);
			sprintf(buffer, "%d", -i);
	 outtextxy(0,SCREENY/2-SCREENY/11*i,buffer);
      }

      // X-Beschriftung

      for (i = 0; i <= 4; i++) {
	 j = ANFANGX+(SCREENX-ANFANGX)/5*i;
	 line(j,SCREENY/2-4,j,SCREENY/2+4);
	sprintf(buffer, "%d", i);
		   outtextxy(j,SCREENY/2+13,buffer);
      }


      outtextxy(ANFANGX+10,0,"s = sinus, r = rechteck, z = zufall, 1 = sampeln, 2 = ausgabe");
  }


/*Ŀ
   Berechnete Mekurve darstellen 				           
  */
  void messkurve(void)
  {
      int SCREENX = getmaxx();
      int SCREENY = getmaxy();
      int i;

      setcolor(EGA_GREEN);

      for (i=0; i < 4095; i++) {
			line(ANFANGX+(int)((float)i*((float)SCREENX-(float)ANFANGX)/5000.0),
		  SCREENY-(int)(((float)(werte[i])*(float)SCREENY)/4096.0),
				  ANFANGX+(int)((float)(i+1)*((float)SCREENX-(float)ANFANGX)/5000.0),
		  SCREENY-(int)(((float)(werte[i+1])*(float)SCREENY)/4096.0)
	      );
      }
  }

/*ͻ
   Hauptprogramm                                                          
  ͼ*/
  int main(void)
  {
    int finished = 0;
    randomize();		//Zufallsgenerator initialisieren

    graphinit();
    koordinaten();
    messkurve();

    while (!finished) {
	 switch(getch()) {
	 case 's':
	   sinus();
	   break;
	 case 'r':
	   rechteck();
	   break;
	 case 'z':
	   zufall();
	   break;
	 case '1':
	   ReadAD();     //Einlesen AD-Wandler
	   finished = 0;
	   break;
	 case '2':
	   WriteDA();    //Ausgabe auf DA-Wandler
	   finished = 0;
	   break;
	 default:
	   finished = 1;
	   break;
       }
       cleardevice();
       koordinaten();
       messkurve();
    }

    closegraph();

    return 0;                   //Rueckgabewert an DOS
  }
