/*ͻ
   Programm  Versuch7.c   (anderer Name als asm-Prog. wegen Object-File) 
                                                                         
   Compiler  Turbo Assembler 3.0 / Borland C++ 3.1                       
                                                                         
   Datum     Karlsruhe, den 04.07.94                                     
                                                                         
   Gruppe                                                                
                                                                         
   Autor     Hartung Wilstermann & Ingo Gabriel                          
  Ķ
   Inhalt    Graphikprogrammierung                                       
  ͼ*/

/*ͻ
   Programmkopf                                                           
  ͼ*/
/*Ŀ
   Includedateien einladen                                                
  */
  #include <graphics.h>
  #include <stdlib.h>
  #include <stdio.h>
  #include <conio.h>
  #include <math.h>
  #include <time.h>

/*Ŀ
   Deklaration fr Assembler                                              
  */
  int wartezeit;                //Wartezeit fr Lauflicht

/*Ŀ
   Deklaration fr C-Programm                                             
  */
  const int maxwert = 4096;		  //Anzahl der berechneten Werte (berech.h)
  int werte[4096];              //Ergebnisse der Berechnungen (berech.h)

  #include "berech.h"           //Diese Includedatei erst nach der
                                //darin benoetigten Variablendeklaration

  #define ANFANGX 40

/*Ŀ
   Prototypendeklaraton                                                   
  */
  extern void Lauflicht(void);	//Lauflicht aus Lauf7.asm (Assembler)
  void graphinit(void);
  void koordinaten(void);
  void messkurve(void);
  void sinus(void);             //in <berech.h> definiert
  void rechteck(void);          //in <berech.h> definiert
  void zufall(void);            //in <berech.h> definiert

/*ͻ
   Unterprogramme                                                         
  ͼ*/

/*Ŀ
   Graphiktreiber initialisieren                                          
  */
  void	graphinit(void)
  {
    int gdriver = DETECT, gmode, errorcode;

    initgraph(&gdriver,&gmode,""); //Graphiktreiber und-mode ermitteln
    errorcode = graphresult();
    if (errorcode != grOk)
    {
	    cprintf("Graphikfehler: %s\n",grapherrormsg(errorcode));
	    cprintf("Drcken Sie eine Taste um anzuhalten:");
	    getch();
	    exit(1);
    };
    setbkcolor(BLACK);          //Hintergrundfarbe setzen
  };



/*Ŀ
   Koordinatensystem aufbauen					           
  */
  void koordinaten(void)
  {
  		int i,j;
      char buffer[10];

      int SCREENX = getmaxx();
      int SCREENY = getmaxy();

      setcolor(EGA_WHITE);

   	// Koordinatenkreuz
		line(0,SCREENY/2,SCREENX,SCREENY/2);
      line(ANFANGX,0,ANFANGX,SCREENY);

      // Y-Beschriftung

      for (i = 0; i <= 5; i++) {
       	line(ANFANGX-4,SCREENY/2+SCREENY/11*i,
         	  ANFANGX+4,SCREENY/2+SCREENY/11*i);
			sprintf(buffer, "%d", i);
         outtextxy(0,SCREENY/2+SCREENY/11*i,buffer);
       	line(ANFANGX-4,SCREENY/2-SCREENY/11*i,
         	  ANFANGX+4,SCREENY/2-SCREENY/11*i);
			sprintf(buffer, "%d", -i);
         outtextxy(0,SCREENY/2-SCREENY/11*i,buffer);
      }

      // X-Beschriftung

      for (i = 0; i <= 4; i++) {
         j = ANFANGX+(SCREENX-ANFANGX)/5*i;
         line(j,SCREENY/2-4,j,SCREENY/2+4);
       	sprintf(buffer, "%d", i);
		   outtextxy(j,SCREENY/2+13,buffer);
      }


      outtextxy(ANFANGX+10,0,"s = sinus, r = rechteck, z = zufall");
  }


/*Ŀ
   Berechnete Mekurve darstellen 				           
  */
  void messkurve(void)
  {
      int SCREENX = getmaxx();
      int SCREENY = getmaxy();
      int i;

      setcolor(EGA_GREEN);

      for (i=0; i < 4095; i++) {
			line(ANFANGX+(int)((float)i*((float)SCREENX-(float)ANFANGX)/5000.0),
         	  SCREENY-(int)(((float)(werte[i])*(float)SCREENY)/4096.0),
				  ANFANGX+(int)((float)(i+1)*((float)SCREENX-(float)ANFANGX)/5000.0),
         	  SCREENY-(int)(((float)(werte[i+1])*(float)SCREENY)/4096.0)
              );
      }
  }

/*ͻ
   Hauptprogramm                                                          
  ͼ*/
  int main(void)
  {
  		int finished = 0;
    randomize();		//Zufallsgenerator initialisieren

    Lauflicht();

    sinus();

    graphinit();
    koordinaten();
    messkurve();

    while (!finished) {
	    switch(getch()) {
   		case 's':
      		sinus();
         	break;
	      case 'r':
				rechteck();
      	   break;
         case 'z':
            zufall();
            break;
         default:
         	finished = 1;
            break;
       }
       cleardevice();
       koordinaten();
       messkurve();
    }

    closegraph();

    return 0;                   //Rueckgabewert an DOS
  }